//-----------------------------------------------------------------------
//  ISPpVAʐM֐  for ATtiny26   by Takuya Matsubara
//-----------------------------------------------------------------------
#include <avr/io.h>
#include "sio.h"

#ifndef F_CPU
#define   F_CPU   8000000    //CPUNbNg 8MHz
#endif

#define BAUDRATE 9600        //{[[g


#define  PRESCALE   4        //vXP[l
#define  PRESCALECR 3        //vXP[ݒl

#define    SIO_PORT PORTB      //ISPp|[g
#define    SIO_PIN  PINB       //ISPp|[g
#define    SIO_DDR  DDRB       //ISPp|[go͐ݒ
#define    SIO_TX   1          //Mrbg
#define    SIO_RX   0          //Mrbg

#define  SIO_TIFR    TIFR    //^C}tO
#define  SIO_MAXCNT  0x100   //^C}ől


#define TCNT_SIO    (SIO_MAXCNT-((F_CPU/PRESCALE)/BAUDRATE))
#define TCNT_1MS    (SIO_MAXCNT-((F_CPU/PRESCALE)/1000))
#define TCNT_50US   (SIO_MAXCNT-((F_CPU/PRESCALE)/(1000000/50)))
#define TCNT_10US   (SIO_MAXCNT-((F_CPU/PRESCALE)/(1000000/10)))
#define TCNT_5US    (SIO_MAXCNT-((F_CPU/PRESCALE)/(1000000/5)))


//-----------------------------------------------------------------------
// EGCg
void sio_wait(unsigned int cnt)
{
    TCNT1 = cnt;
    SIO_TIFR |= (1 << TOV1);  // TIFR̃rbgNA

    while(!(SIO_TIFR & (1 << TOV1)));
    // TOV1rbg1ɂȂ܂
}


//-----------------------------------------------------------------------
void sio_init(void)
{
	// VA|[g
	SIO_DDR |=  (1<<SIO_TX);
	SIO_PORT &= ~(1<<SIO_TX);

    TCCR1A= 0;                // ^C}1 [h 
    TCCR1B= PRESCALECR;       // ^C}1 vXP[ݒ
}

//-----------------------------------------------------------------------
// 1oCgM
// sio_txdatFMf[^0x00-0xff
void sio_tx(char sio_txdat)
{
    unsigned char mask = 0x01;

    //X^[grbg
    SIO_PORT |= (1<<SIO_TX);
    sio_wait(TCNT_SIO);

    //f[^rbg0-7(ʂ瑗M)
    while(mask != 0){    
        if(sio_txdat & mask)
    	    SIO_PORT &= ~(1<<SIO_TX);
	    else
        	SIO_PORT |= (1<<SIO_TX);

	    sio_wait(TCNT_SIO);
        mask = mask<<1;
    }
    //Xgbvrbg
    SIO_PORT &= ~(1<<SIO_TX);
    sio_wait(TCNT_SIO);
}

void sio_txhex(unsigned char i)
{
    unsigned char tmp;

	tmp = (i >> 4) + '0';
    if(tmp > '9') tmp += 7;	//A-Fɕϊ
	sio_tx(tmp);

    tmp = (i & 0xF) + '0';
    if(tmp > '9') tmp += 7;	//A-Fɕϊ
	sio_tx(tmp);
}
